#!/usr/bin/perl

use warnings;
use strict;

use Digest::SHA1 qw(sha1_hex);

# Download CryptoPhoto Perl lib from https://cryptophoto.com/admin/api
use CryptoPhotoUtils;
use CGI;

my $server      = "https://cryptophoto.com";
my $private_key = "xxx"; # Your CryptoPhoto Private API Key
my $public_key  = "yyy"; # Your CryptoPhoto Public API Key
my $salt        = "random-salt-string";
my $uid         = "userId"; # Your users internal ID
my $tvkey       = "key-of-a-transaction-verification-template"; # see https://cryptophoto.com/info/cptv-templates and https://cryptophoto.com/admin/api-docs#header-ecryption-and-decryption

my $cgi   = CGI->new();
my $_POST = $cgi->Vars();

my $display  = '';
my $value    = '';
my $doingDecryption = 0;

if (exists $_POST->{'value_cpencrypt'} && exists $_POST->{'value'} && $_POST->{'value'}) {

  if (exists $_POST->{'cpJWSrfc7515'} && exists $_POST->{'cpTVresponse'}) {

    my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
    my $response = $cp->verify_cptv_response($_POST); # verify transaction response

    if ($response->{'is_valid'}) {# response validate

      $display = '<p>Value encrypted</p>';
      $value = $_POST->{'value'};
      $doingDecryption = 1;

    } else {
      $display = '<p>' . $response->{'error'} . '</p>';
    }
  }
} elsif (exists $_POST->{'value_cpdecrypt'} && exists $_POST->{'value'} && $_POST->{'value'}) {

  if (exists $_POST->{'cpJWSrfc7515'} && exists $_POST->{'cpTVresponse'}) {

    my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
    my $response = $cp->verify_cptv_response($_POST); # verify transaction response

    if ($response->{'is_valid'}) {# response validate

      $display = '<p>Value decrypted</p>';
      $value = $_POST->{'value'};
      $doingDecryption = 0;

    } else {
      $display = '<p>' . $response->{'error'} . '</p>';
    }
  }
}

my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
my $response = $cp->start_session($ENV{'REMOTE_ADDR'});
my $sid;
if ($response->{'is_valid'}) {
  $sid = $response->{'sid'};
} else {
  $display .= '<p>' .
      $response->{'error'} . ( $response->{'errdesc'} ? ' ' . $response->{'errdesc'} : '' ) .
      '</p>';
}
 
$display .= '<form action="" method="post">' .
            'Value:<br> <textarea rows="5" name="value" >' . $value . '</textarea><br>';
          
if (!$doingDecryption) {
  $display .= '<input type="hidden" name="value_cpencrypt"><br><br>' . 
	      '<input type="submit" value="Encrypt">';
} else {
  $display .= '<input type="hidden" name="value_cpdecrypt"><br>' . 
	      '<input type="submit" value="Decrypt">' ;
}

$display .= '</form>';
 
if ($sid) {
  $display .= "<script type='text/javascript' src='".$server."/api/tv?key=".$tvkey."&sid=".$sid."' async='true'></script>";
}
 
my $out=<<HTML;
Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Encrypt/Decrypt Value</title>
</head>
<body style="text-align:center">
  <h2>Encrypt/Decrypt Value</h2>
  $display
</body>
</html>
HTML

print $out;